"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _objectSpread3 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/objectSpread"));

var _compose = _interopRequireDefault(require("recompose/compose"));

var _withStateHandlers = _interopRequireDefault(require("recompose/withStateHandlers"));

var _withHandlers = _interopRequireDefault(require("recompose/withHandlers"));

var withFields = function withFields(initialStateFn) {
  return function (Cmp) {
    return (0, _compose.default)((0, _withStateHandlers.default)({
      fields: initialStateFn || {}
    }, {
      setFields: function setFields() {
        return function (payload) {
          return {
            fields: payload
          };
        };
      },
      setField: function setField(_ref) {
        var fields = _ref.fields;
        return function (key, value) {
          return (0, _objectSpread3.default)({}, fields, (0, _defineProperty2.default)({}, key, value));
        };
      }
    }), (0, _withHandlers.default)({
      handleFieldChange: function handleFieldChange(_ref2) {
        var fields = _ref2.fields,
            setFields = _ref2.setFields;
        return function (_ref3) {
          var target = _ref3.target;
          var newFields = (0, _objectSpread3.default)({}, fields);

          if (target.type === 'checkbox') {
            if (target.checked) {
              newFields[target.name] = target.value;
            } else {
              delete newFields[target.name];
            }
          } else if (target.value !== '') {
            newFields[target.name] = target.value;
          } else {
            delete newFields[target.name];
          }

          setFields(newFields);
        };
      }
    }))(Cmp);
  };
};

var _default = withFields;
exports.default = _default;